\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{doc-setup}[2004/04/01 v1.1 typeset chapter like section]
%\usepackage[danish]{babel}
%\usepackage[latin1]{inputenc}
\usepackage{pstricks}
%\usepackage{a4wide}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{epsfig}
\usepackage{float}
\usepackage{listings} 
\usepackage{fancyvrb}
\usepackage{fancyheadings}
\usepackage{shadow}
\usepackage{rotate}
\usepackage{rotating}
\usepackage{picinpar}
\usepackage{enumerate}
\usepackage{pifont}

\usepackage{varioref}
\usepackage{alltt}
%\usepackage[nottoc]{tocbibind}
\usepackage{calc}

\usepackage{pst-grad}
\usepackage{pst-text}
\usepackage{pst-char}
\usepackage{pst-node}
\usepackage{multido}
\usepackage{ifthen}

\newlength\sec@ident
\setlength\sec@ident{0.1in}

\newlength\sec@width
\setlength\sec@width{\sec@ident}
\addtolength\sec@width{\linewidth}
\definecolor{orange}{rgb}{1,0.64,0}
\definecolor{transistioncolor}{rgb}{0,0.5,0}

\def\headersection#1{%
  \psset{fillstyle=solid, linecolor=orange}%
  \hspace{-\sec@ident}%
  \begin{pspicture}(0,0)(\sec@width,1.1)
    \pspolygon*%
    (0, 0)(0.75, 0.5)(0,1)%
    %\pspolygon*(0, 0)(\sec@width, 0)(\sec@width, 1pt)(0, 1pt)%
    \rput[lb](0.2,0.15){\Large\bf \textcolor{forecolor}{#1}}%
\end{pspicture}}

\def\headersubsection#1{%
   \psset{fillstyle=solid, linecolor=orange}%
   \hspace{-\sec@ident}%
   \begin{pspicture}(0,0)(\sec@width,0.8)
     %\psframe(\sec@width,0.8){}
     \pspolygon*%
     (0, 0)(0.5, 0.25)(0,0.5)%
     \rput[lt](0.35,0.4){\large\bf \textcolor{forecolor}{#1}}%
   \end{pspicture}}

 \def\headersubsubsection#1{%
   \psset{fillstyle=solid, linecolor=orange}%
   \hspace{-\sec@ident}%
   \begin{pspicture}(0,0)(\sec@width,0.6)
     %\psframe(\sec@width,0.6){}
     \pspolygon*%
     (0, 0)(0.5, 0)(0.5, 0.5)(0, 0.5)%
     \rput[lm](0.75,0.25){\large\bf \textcolor{forecolor}{#1}}%
   \end{pspicture}}


\newif\if@noskipsec%
\@noskipsectrue%

\def\unnumberedSection#1{
\csname header\@secType\endcsname{#1}%
\par\nobreak
}

\def\sectiontitle{}
\def\numberedSection#1{%
  \def\sectiontitle{#1}
  \refstepcounter{\@secType}%
  \addcontentsline{toc}{\@secType}{%
    \protect\numberline{\csname the\@secType\endcsname}%
    #1}%
%\protect{\csname the\@secType\endcsname} - #1\par
\csname header\@secType \endcsname{\csname the\@secType \endcsname%
  \quad #1}%
\def\@secType{}
\par \nobreak%
%\vskip 0.5\baselineskip%
\@afterheading%
\hskip -\parindent
}

\def\@presec{%
  \leavevmode\par
  \@tempskipa 0pt\relax%
  \ifdim \@tempskipa < \z@%
  \@tempskipa -\@tempskipa%
  \@afterindentfalse%
  \fi%
  \@afterindenttrue%
  \if@nobreak%
    \everypar{}%
  \else%
    \addpenalty\@secpenalty%
    \addvspace\@tempskipa%
  \fi%
  \@tempskipa 0pt\relax%
  \unskip}

\def\section{
  \@presec
  \def\@secType{section}%
  \par\nobreak\hskip -\parindent
  \@ifstar\unnumberedSection\numberedSection%
}

\def\subsection{
  \@presec
  \def\@secType{subsection}%
  \par\nobreak\hskip -\parindent
  \@ifstar\unnumberedSection\numberedSection%
}

\def\subsubsection{
  \@presec
  \def\@secType{subsubsection}%
  \par\nobreak\hskip -\parindent
  \@ifstar\unnumberedSection\numberedSection%
}

\def\paragraph{\@startsection{paragraph}{4}{\z@}%
  {3.25ex \@plus1ex \@minus.2ex}%
  {-1em}%
  {\normalfont\normalsize\bfseries\color{forecolor}}}

\def\subparagraph{\@startsection{subparagraph}{5}{\parindent}%
  {3.25ex \@plus1ex \@minus .2ex}%
  {-1em}%
  {\normalfont\normalsize\bfseries\color{forecolor}}}

%% \def\@makechapterhead#1{%
%%   \vspace*{50\p@}%
%%   {\parindent \z@ \raggedright \normalfont
%%     \ifnum \c@secnumdepth >\m@ne
%%         \huge\bfseries \@chapapp\space \thechapter
%%         \par\nobreak
%%         \vskip 20\p@
%%     \fi
%%     \interlinepenalty\@M
%%     \Huge \bfseries #1\par\nobreak
%%     \vskip 40\p@
%%   }}


\def\chapterpic#1#2{}
\def\chap@pic{}
\def\chap@cap{}
\def\produceChapterPics{\def\chapterpic##1##2{\def\chap@pic{##1}%
    \def\chap@cap{%
      \begin{minipage}{3.5cm}\raggedright
      \begin{pspicture}(0.5,0.4)%
        %\psframe*[linecolor=blueback](0,0,)(0.5,0.4){}
        \pspolygon*[linecolor=orange](0.1,0.15)(0.4,0.3)(0.4,0)%
      \end{pspicture} \small ##2\end{minipage}}%
}}
\newlength{\chap@height}
\newlength{\chap@e@height}
\newlength{\chap@extra}
\chap@extra 1.5cm
\def\chaptertitle{}%
\def\@makechapterhead#1{%
  \def\chaptertitle{#1}%
  \parindent \z@ 
  \def\ch@head{\fontsize{100}{110pt}\selectfont \textcolor{forecolor}{\thechapter}}
  \settoheight{\chap@height}{\chap@pic}%
  \setlength\chap@e@height\chap@height%
  \addtolength\chap@e@height{\chap@extra}%
  \begin{pspicture}(\linewidth,\chap@height)
    %\psframe[linecolor=blueback](0,\chap@extra)(\linewidth,\chap@e@height){}
    %\psline[linewidth=5pt,linecolor=orange]{-}(-1cm,1)({10cm},1)
    \rput[lt](0,\chap@e@height){\chap@pic}%
    \rput[lb](0,0.5){\huge\bf #1}%
    \rput[tr](16.5,\chap@e@height){%
    \rput[tr](1,0){%
%%      \pspolygon*[linecolor=forecolor,linearc=2](-0.8,5)(2,5)(2,-29)(0,-29)(0,-6)(-0.8,-4)%
      \pspolygon*[linecolor=forecolor](-0.8,1.1)(0.6,1.1)(0.6,-24.4)(0,-24.4)(0,-7)(-0.8,-5)}%
    \rput[tr](1,-1){\rotatebox{270}{\Large \textcolor{white}{C h a p t e r}}} %
    \rput[tr](0,-1){\ch@head}%
    }%
    \rput[bl](12.5,\chap@extra){\chap@cap}%
  \end{pspicture}
  \def\chap@pic{}
  \def\chap@cap{}
}

\def\@makeschapterhead#1{%
  \vspace*{10\p@}%
  {\parindent \z@ \raggedright
    \normalfont
    \interlinepenalty\@M
    \Huge \bfseries \textcolor{forecolor}{#1}\par\nobreak
    \psline[linewidth=5pt,linecolor=orange]{-}(-0.5in,0.5)(14,0.5)
    \vskip 10\p@
  }}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
\def\mytitlepage{\begin{titlepage}
    \DeclareFixedFont{\Sf}{T1}{phv}{b}{n}{0.9cm}
    \DeclareFixedFont{\Rm}{T1}{ptm}{m}{n}{3mm}
    \hskip -1.7in
    \begin{pspicture}(16,21)
      %\psframe(16,22){}
      \psframe*[linecolor=darkblue](0,18.5)(16,22){}
      \rput[mb](8,20.3){\Sf\textcolor{white}{COMMUNICATION ALGORITHMS}}
      \rput[mt](8,20){\Sf\textcolor{white}{IN THE ODIN ROBOT}}
      \rput[mt](8,18.4){\textcolor{darkblue}{\large Forprojekt til speciale}}
      \rput[mt](8,16){\epsfig{file=pics/odin,width=12cm}}
      \rput(0,1){
      \psframe*[linecolor=darkblue](0,2.5)(16,0){}
      \rput[lb](2,1.5){\textcolor{white}{\Large Author: Peter Tobias G\o nge Nielsen}}%
      \rput[lb](2,1){\textcolor{white}{\Large Supervisor: Kasper Stoy}}%
      \rput[lb](2,0.5){\textcolor{white}{\Large Date: \today}}%
      }
      \rput[lt](0,0.9){The Maersk Mc-Kinney Moller Institute}
      \rput[rt](16,0.9){University of Southern Denmark}
    \end{pspicture}
  \end{titlepage}}%

\newcommand{\desclistlabel}[1]{\mbox{\textbf{#1}} }

\newenvironment{desclist}%
  {\begin{list}{}%
      {\renewcommand{\makelabel}{\desclistlabel}%
        \setlength{\labelwidth}{10pt}%
        \setlength{\leftmargin}{\labelwidth}%
        \addtolength{\leftmargin}{\labelsep}%
        %\setlength{\itemindent}{\labelsep}%
        \setlength{\labelsep}{0pt}%       
        \setlength{\itemsep}{0pt}%
      }%
  }%
  {\end{list}}


\def\ps@arrow@up{
  \begin{pspicture}(0.4,0.2)
    \pspolygon*[linecolor=red](0,0)(0.15,0.2)(0.3,0)
  \end{pspicture}
}

\def\ps@arrow@left{
  \begin{pspicture}(0.2,0.2)
    \pspolygon*[linecolor=red](0.2,0)(0,0.15)(0.2,0.3)
  \end{pspicture}
}

\def\ps@arrow@right{
  \begin{pspicture}(0.2,0.2)
    \pspolygon*[linecolor=red](0,0)(0.2,0.15)(0,0.3)
  \end{pspicture}
}

\newsavebox{\sidefigbox}
\newenvironment{sidefig}{%
  \parindent \z@%
   \ifthenelse{\not\isodd{\value{page}}}%
              {\def\figside{l}}%
              {\def\figside{r}}%
  \renewcommand\caption[2][empty]{\ifthenelse{\equal{##1}{empty}}%
    {\global\def\fig@subcab{##2}}%
    {\global\def\fig@subcab{##1}}%
    \global\def\fig@cap{##2}}%
  \refstepcounter{figure}%
  \begin{lrbox}{\sidefigbox}%
    \global\def\fig@cap{}%
    \global\def\fig@subcab{}%
}{%
  \end{lrbox}%
 \ifthenelse{\equal{l}{\figside}}
  {%
    \begin{pspicture}(0,0)%
      \rput[lb](\textwidth,0){\rput[lb](0.3,0){%
          \parbox{4.5cm}{%
            \raggedright\usebox{\sidefigbox}}}%
      }%
      \rput[lb](\textwidth,0){\rput[lt](0.3,-0.1){%
          \parbox{4.5cm}{\raggedright%
            \ps@arrow@up
            {\bf \textcolor{forecolor}{Figure \thefigure:}} %
            \small\fig@cap}%
      }}%
    \end{pspicture}%
  }%
  {%
    \begin{pspicture}(0,0)%
      \rput[rb](-0.55cm,0cm){%
        \parbox{4.5cm}{%
          \raggedright\usebox{\sidefigbox}}%
      }%
      \rput[rt](-0.45cm,-0.2cm){%
        \parbox{4.5cm}{\raggedright %
          {%
            \ps@arrow@up %
            \bf\textcolor{forecolor}{Figure \thefigure:}} %
          \small\fig@cap}%
      }%
    \end{pspicture}%
 }%
  \addcontentsline{lof}{figure}{\protect\numberline{\thefigure} \fig@subcab}%
  \global\let\fig@cap\relax%
}

\newsavebox{\FrameBox}
\newlength{\FrameHgt}
\newlength{\InnerFrameHgt}
\newlength{\FrameWdt}
\newlength{\HeaderWdt}

\newenvironment{Figure}[1][0]{
  \parindent \z@\par %
  \ifthenelse{\not\isodd{\value{page}}}%
             {\def\figside{l}}%
             {\def\figside{r}}%
  \global\def\fig@ruled{}
    \def\setRuled{
      %\global\def\fig@ruled{y}
    }
  \renewcommand\caption[2][empty]{\ifthenelse{\equal{##1}{empty}}%
    {%
      \global\def\fig@subcab{##2}%
    }{%
      \global\def\fig@subcab{##1}%
    }%
    \global\def\fig@cap{##2}%
  }%
  \def\Fig@floatname{#1}
  \refstepcounter{figure}%
\begin{lrbox}{\sidefigbox}%
  \global\def\fig@cap{}%
  \global\def\fig@subcab{}%
}{%
  \end{lrbox}%
  \settoheight{\FrameHgt}{\usebox\sidefigbox}
  \parbox{\textwidth}{
    \begin{pspicture}(\textwidth,\FrameHgt)
      %\psframe(\textwidth,\FrameHgt){}
    \rput[mb](0.5\textwidth,0){\usebox{\sidefigbox}}
    \ifthenelse{\equal{l}{\figside}}%
      {
        \ifthenelse{\equal{\fig@ruled}{y}}{
          \rput[lt](0,\FrameHgt){
            \psline[linecolor=orange,linewidth=3pt](0,0)(17,0)
          }
          \rput[lt](0,0){
            \psline[linecolor=orange,linewidth=3pt](0,0)(17,0)
          }
        }{}
        \rput[lt](\textwidth,\FrameHgt){\rput[lt](0.5,-0.2){%
          \parbox{4.5cm}{%
            \raggedright%
                {%
                  \ps@arrow@left
            \bf\textcolor{forecolor}{Figure
            \thefigure:}} %
                \small \fig@cap}
        }}
      }
      {
        \ifthenelse{\equal{\fig@ruled}{y}}{
          \rput[lt](0,\FrameHgt){
            \psline[linecolor=orange,linewidth=3pt](-5.7,0)(\textwidth,0)
          }
          \rput[lt](0,0){
            \psline[linecolor=orange,linewidth=3pt](-5.7,0)(\textwidth,0)
          }
        }{}
        \rput[rt](-1cm,\FrameHgt){\rput[rt](0,-0.3){%
          \parbox{4.5cm}{%
            \raggedright%
                {%
                  \ps@arrow@right
            \bf\textcolor{forecolor}{Figure
            \thefigure:}} %
                \small \fig@cap}
        }}
      }
      %\psframe[fillstyle=none](\textwidth,\FrameHgt){}
    \end{pspicture}
  }
  \addcontentsline{lof}{figure}{\protect\numberline{\thefigure} \fig@subcab}
  \global\let\fig@cap\relax
  \global\let\fig@subcab\relax
}

\newenvironment{slbb}[1]%
  {\def\theTitle{\textbf{\textsf{#1}}}
    \setlength{\FrameWdt}{\linewidth}%
    \addtolength{\FrameWdt}{-1cm}%
    \begin{lrbox}{\FrameBox}%
      \begin{minipage}{\FrameWdt}%
  }%
  {\end{minipage}\end{lrbox}%
    \setlength{\FrameWdt}{\linewidth}%
    \settoheight{\FrameHgt}{\usebox{\FrameBox}}%
    \settowidth{\HeaderWdt}{\theTitle\hspace{0.11cm}}
    \addtolength{\FrameHgt}{\FrameHgt}%
    \setlength{\InnerFrameHgt}{\FrameHgt}
    \addtolength{\FrameHgt}{1cm}%
    \begin{pspicture}(\linewidth,\FrameHgt)
      %\rput[l](0,2\FrameHgt){\textbf{\textcolor{white}{\theTitle}}}
      \rput[lb](0.1,0.2){\usebox{\FrameBox}}%
      \rput[lb](0,\InnerFrameHgt){%
        \psframe*[linecolor=forecolor](-0.2,0.7\baselineskip)(\HeaderWdt,2.2\baselineskip){}
        \rput[lb](0,\baselineskip){\textcolor{white}{\theTitle}}
        \rput[rb](\linewidth,-\InnerFrameHgt){\psframe*[linecolor=forecolor](0,0)(-0.3,0.3){}}
        \psline[linewidth=2pt,linecolor=forecolor,fillstyle=none]{-}(-0.2,2.2\baselineskip)(-0.2,-\InnerFrameHgt)(\linewidth,-\InnerFrameHgt)
      }
    \end{pspicture}
  }

%\settowidth{\labelwidth}{35pt}%

%%% pstricks placement

\definecolor{blueback}{rgb}{0.8,0.8,1}
\definecolor{darkblue}{rgb}{0,0,0.6}
\definecolor{forecolor}{rgb}{0,0,0.5}

\def\vertex{\pscircle[linewidth=0.5pt](0,0){0.4}\psarc(0,0){0.2}{-45}{225}}

\def\odinnode(#1,#2)#3{\cnode[fillstyle=none,linecolor=black](#1,#2){.3}{#3}%
  \psarc[fillstyle=none,linecolor=black](#1,#2){0.18}{-45}{225}}
\def\emptynode(#1,#2)#3{\pnode(#1,#2){#3}}

\def\conline#1#2{\ncline[fillcolor=white,linecolor=black,linewidth=4pt]{-}{#1}{#2}}
\def\dconline#1#2{\ncline[fillcolor=white,linecolor=red,linewidth=4pt]{-}{#1}{#2}}
\def\uconline#1#2{
  \ncline[fillcolor=white,linecolor=black,linewidth=1pt,linestyle=dotted]{-}{#1}{#2}}
\def\askedline#1#2{
  \ncline[fillcolor=white,linecolor=black,linewidth=1pt,linestyle=dashed]{-}{#1}{#2}
  \ncput*[fillcolor=white,linecolor=black]{?}}
\def\askingline#1#2{
  \ncline[fillcolor=blueback,linecolor=black,linewidth=1pt,linestyle=dashed]{->}{#1}{#2}}

\lstset{basicstyle=\small,
  keywordstyle=\color{black}\bfseries\underbar,
  stringstyle=\ttfamily,
  language=c,
  numbers=left,
  backgroundcolor=\color{blueback},
  emphstyle=\bfseries\underbar}

\newfloat{program}{ht!}{loa}[section]
\floatname{program}{Program}

\def\Atron{\emph{Atron} }
\def\Odin{\emph{Odin} }
\def\mip{\emph{Maersk Mc-Kinney Moller Institute at the University of
    Southern Denmark} }

\def\todo#1{{\par\noindent \color{red} \bf (#1)\par}}
\def\dropTodos{\chapter{Todos.}%
  \textbf{List of known tasks (Todo)}%
  \begin{itemize} %
    \item Yet to come this implementation %
  \end{itemize} %
}

  \makeatletter
   \newcommand\ps@mypagestyle{%
     \renewcommand{\@oddhead}{\begin{pspicture}(0,0)
       \rput[lt](-5.7cm,1){
         {\bf\thepage}
         \psline[linecolor=black](0.2,-0.2)(0.2,0.4)\hspace{10pt}
         \chaptertitle
       }
       \rput[rb](-6cm,1.6){
         \psline[linecolor=black,linewidth=0.5pt](0,0.2)(0,0.7)
         \psline[linecolor=black,linewidth=0.5pt](-0.2,0)(-0.7,0)
       }
       \end{pspicture}
     }

     \renewcommand{\@evenhead}{\begin{pspicture}(0,0)
       \rput[rt](17.7cm,1){
         \thesection \hspace{5pt}
         \sectiontitle \hspace{10pt}
         \psline[linecolor=black,linewidth=1pt](0.2,-0.2)(0.2,0.4)\hspace{10pt}
         {\bf\thepage}
       }
       \rput[lb](18cm,1.6){
         \psline[linecolor=black,linewidth=0.5pt](0,0.2)(0,0.7)
         \psline[linecolor=black,linewidth=0.5pt](0.2,0)(0.7,0)
       }
       \end{pspicture}
     }%
     \renewcommand{\@evenfoot}{\begin{pspicture}(0,0)
         \rput[lt](18cm,-0.6){
         \psline[linecolor=black,linewidth=0.5pt](0,-0.2)(0,-0.7)
         \psline[linecolor=black,linewidth=0.5pt](0.2,0)(0.7,0)
       }
       \end{pspicture}
     }%
     \renewcommand{\@oddfoot}{\begin{pspicture}(0,0)
         \rput[lt](-6cm,-0.6){
         \psline[linecolor=black,linewidth=0.5pt](0,-0.2)(0,-0.7)
         \psline[linecolor=black,linewidth=0.5pt](-0.2,0)(-0.7,0)
       }
       \end{pspicture}
     }
   }
   \renewcommand\ps@plain{%
     \renewcommand{\@oddhead}{\begin{pspicture}(0,0)
       \rput[rb](-6cm,1.6){
         \psline[linecolor=black,linewidth=0.5pt](0,0.2)(0,0.7)
         \psline[linecolor=black,linewidth=0.5pt](-0.2,0)(-0.7,0)
       }
       \end{pspicture}
     }

     \renewcommand{\@evenhead}{\begin{pspicture}(0,0)
       \rput[lb](18cm,1.6){
         \psline[linecolor=black,linewidth=0.5pt](0,0.2)(0,0.7)
         \psline[linecolor=black,linewidth=0.5pt](0.2,0)(0.7,0)
       }
       \end{pspicture}
     }%
     \renewcommand{\@evenfoot}{\begin{pspicture}(0,0)
         \rput[lt](18cm,-0.6){
         \psline[linecolor=black,linewidth=0.5pt](0,-0.2)(0,-0.7)
         \psline[linecolor=black,linewidth=0.5pt](0.2,0)(0.7,0)
       }
       \end{pspicture}
     }%
     \renewcommand{\@oddfoot}{\begin{pspicture}(0,0)
         \rput[lt](-6cm,-0.6){
         \psline[linecolor=black,linewidth=0.5pt](0,-0.2)(0,-0.7)
         \psline[linecolor=black,linewidth=0.5pt](-0.2,0)(-0.7,0)
       }
       \end{pspicture}
     }
   }
   \makeatother

\endinput
